OGRE: Ogre::BillboardSet Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::BillboardSet Class Reference
Core » Effects

A collection of billboards (faces which are always facing the given direction) with the same (default) dimensions, material and which are fairly close proximity to each other. More...

`#include <OgreBillboardSet.h>`

Inheritance diagram for Ogre::BillboardSet:
[legend]

## Public Member Functions
| BillboardSet (const String &name, unsigned int poolSize=20, bool externalDataSource=false)
| Usual constructor - this is called by the SceneManager.
virtual | ~BillboardSet ()
virtual SortMode | _getSortMode (void) const
| Gets the sort mode of this billboard set.
void | _notifyCurrentCamera (Camera *cam) override
| Internal method to notify the object of the camera to be used for the next rendering operation.
void | _releaseManualHardwareResources () override
| Notifies the movable object that hardware resources were lost.
virtual void | _sortBillboards (Camera *cam)
| Sort the billboard set.
virtual void | _updateBounds (void)
| Update the bounds of the billboardset.
void | _updateRenderQueue (RenderQueue *queue) override
| Internal method by which the movable object must add Renderable subclass instances to the rendering queue.
void | beginBillboards (size_t numBillboards=0)
| Begin injection of billboard data; applicable when constructing the BillboardSet for external data use.
virtual void | clear ()
| Empties this set of all billboards.
Billboard * | createBillboard (const Vector3 &position, const ColourValue &colour=ColourValue::White)
| Creates a new billboard and adds it to this set.
Billboard * | createBillboard (Real x, Real y, Real z, const ColourValue &colour=ColourValue::White)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | endBillboards (void)
| Finish defining billboards.
bool | getAutoextend (void) const
| Returns true if the billboard pool automatically extends.
bool | getAutoUpdate (void) const
| Return the auto update state of this billboard set.
virtual Billboard * | getBillboard (unsigned int index) const
| Returns a pointer to the billboard at the supplied index.
bool | getBillboardsInWorldSpace ()
| Gets whether billboards are treated as being in world space.
const AxisAlignedBox & | getBoundingBox (void) const override
| Retrieves the local axis-aligned bounding box for this object.
Real | getBoundingRadius (void) const override
| Retrieves the radius of the origin-centered bounding sphere for this object.
bool | getCullIndividually (void) const
| Returns whether or not billboards in this are tested individually for culling.
const LightList & | getLights (void) const override
| Gets a list of lights, ordered relative to how close they are to this renderable.
const MaterialPtr & | getMaterial (void) const override
| Retrieves a weak reference to the material this renderable object uses.
const String & | getMaterialName (void) const
| Sets the name of the material to be used for this billboard set.
const String & | getMovableType (void) const override
| Returns the type name of this object.
int | getNumBillboards (void) const
| Returns the number of active billboards which currently make up this set.
unsigned int | getPoolSize () const
| Returns the current size of the billboard pool.
void | getRenderOperation (RenderOperation &op) override
| Gets the render operation required to send this object to the frame buffer.
bool | getSortingEnabled (void) const
| Returns true if sorting of billboards is enabled based on their distance from the camera.
Real | getSquaredViewDepth (const Camera *cam) const override
| Returns the squared distance between the camera and this renderable.
uint32 | getTypeFlags (void) const override
| Override to return specific type flag.
void | getWorldTransforms (Matrix4 *xform) const override
| Gets the world transform matrix / matrices for this renderable object.
void | injectBillboard (const Billboard &bb)
| Define a billboard.
bool | isPointRenderingEnabled (void) const
| Returns whether point rendering is enabled.
void | notifyBillboardDataChanged (void)
| When billboard set is not auto updating its GPU buffer, the user is responsible to inform it about any billboard changes in order to reflect them at the rendering stage.
virtual void | removeBillboard (Billboard *pBill)
| Removes a billboard from the set.
virtual void | removeBillboard (unsigned int index)
| Removes the billboard at the supplied index.
void | setAutoextend (bool autoextend)
| Tells the set whether to allow automatic extension of the pool of billboards.
void | setAutoUpdate (bool autoUpdate)
| Set the auto update state of this billboard set.
void | setBillboardsInWorldSpace (bool ws)
| Sets whether billboards should be treated as being in world space.
void | setBounds (const AxisAlignedBox &box, Real radius)
| Set the bounds of the BillboardSet.
void | setCullIndividually (bool cullIndividual)
| Sets whether culling tests billboards in this individually as well as in a group.
virtual void | setMaterial (const MaterialPtr &material)
| Sets the name of the material to be used for this billboard set.
virtual void | setMaterialName (const String &name, const String &groupName=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME)
| Sets the name of the material to be used for this billboard set.
virtual void | setPointRenderingEnabled (bool enabled)
| Set whether or not the BillboardSet will use point rendering rather than manually generated quads.
void | setPoolSize (size_t size)
| Adjusts the size of the pool of billboards available in this set.
void | setSortingEnabled (bool sortenable)
| Enables sorting for this BillboardSet.
void | visitRenderables (Renderable::Visitor *visitor, bool debugRenderables=false) override
| Method to allow a caller to abstractly iterate over the Renderable instances that this MovableObject will add to the render queue when asked, if any.
Billboard positioning
void | setBillboardOrigin (BillboardOrigin origin)
| Sets the point which acts as the origin point for all billboards in this set.
BillboardOrigin | getBillboardOrigin (void) const
| Gets the point which acts as the origin point for all billboards in this set.
void | setBillboardRotationType (BillboardRotationType rotationType)
| Sets billboard rotation type.
BillboardRotationType | getBillboardRotationType (void) const
| Sets billboard rotation type.
void | setDefaultDimensions (Real width, Real height)
| Sets the default dimensions of the billboards in this set.
void | setDefaultWidth (Real width)
| See setDefaultDimensions - this sets 1 component individually.
Real | getDefaultWidth (void) const
| See setDefaultDimensions - this gets 1 component individually.
void | setDefaultHeight (Real height)
| See setDefaultDimensions - this sets 1 component individually.
Real | getDefaultHeight (void) const
| See setDefaultDimensions - this gets 1 component individually.
Billboard orientation
void | setBillboardType (BillboardType bbt)
| Sets the orientation behaviour of the billboards to render.
BillboardType | getBillboardType (void) const
| Returns the billboard type in use.
void | setCommonDirection (const Vector3 &vec)
| Use this to specify the common direction given to billboards.
const Vector3 & | getCommonDirection (void) const
| Gets the common direction for all billboards (BBT_ORIENTED_COMMON).
void | setCommonUpVector (const Vector3 &vec)
| Use this to specify the common up-vector given to billboards.
const Vector3 & | getCommonUpVector (void) const
| Gets the common up-vector for all billboards (BBT_PERPENDICULAR_SELF and BBT_PERPENDICULAR_COMMON).
void | setUseAccurateFacing (bool acc)
| Sets whether or not billboards should use an 'accurate' facing model.
bool | getUseAccurateFacing (void) const
| Gets whether or not billboards use an 'accurate' facing model.
Billboard UV computation
void | setTextureCoords (const std::vector< FloatRect > &coords)
| BillboardSet can use custom texture coordinates for various billboards.
void | setTextureCoords (FloatRect const *coords, uint16 numCoords)
void | setTextureStacksAndSlices (uchar stacks, uchar slices)
| Generate texture coordinate rects for a tiled texture sheet.
const std::vector< FloatRect > & | getTextureCoords () const
| getTextureCoords() returns the current texture coordinate rects in effect.
Public Member Functions inherited from Ogre::MovableObject
| MovableObject ()
| Constructor.
| MovableObject (const String &name)
| Named constructor.
virtual | ~MovableObject ()
| Virtual destructor - read Scott Meyers if you don't know why this is needed.
MovableObjectFactory * | _getCreator (void) const
| Get the creator of this object, if any (internal use only).
LightList * | _getLightList ()
| Returns a pointer to the current list of lights for this object.
SceneManager * | _getManager (void) const
| Get the manager of this object, if any (internal use only).
virtual const Affine3 & | _getParentNodeFullTransform (void) const
| Return the full transformation of the parent sceneNode or the attachingPoint node.
virtual void | _notifyAttached (Node *parent, bool isTagPoint=false)
| Internal method called to notify the object that it has been attached to a node.
virtual void | _notifyCreator (MovableObjectFactory *fact)
| Notify the object of it's creator (internal use only).
virtual void | _notifyManager (SceneManager *man)
| Notify the object of it's manager (internal use only).
virtual void | _notifyMoved (void)
| Internal method called to notify the object that it has been moved.
virtual void | _restoreManualHardwareResources ()
| Notifies the movable object that hardware resources should be restored.
void | addQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | addVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | detachFromParent (void)
| Detaches an object from a parent SceneNode or TagPoint, if attached.
Real | getBoundingRadiusScaled () const
| as getBoundingRadius, but with scaling applied
bool | getCastShadows (void) const override
| Returns whether shadow casting is enabled for this object.
uint32 | getLightMask () const
| Get a bitwise mask which will filter the lights affecting this object.
Listener * | getListener (void) const
| Gets the current listener for this object.
const String & | getName (void) const
| Returns the name of this object.
Node * | getParentNode (void) const
| Returns the node to which this object is attached.
SceneNode * | getParentSceneNode (void) const
| Returns the scene node to which this object is attached.
Real | getPointExtrusionDistance (const Light *l) const override
| Get the distance to extrude for a point/spot light.
virtual uint32 | getQueryFlags (void) const
| Returns the query flags relevant for this object.
bool | getReceivesShadows ()
| Returns whether the Material of any Renderable that this MovableObject will add to the render queue will receive shadows.
Real | getRenderingDistance (void) const
| Gets the distance at which batches are no longer rendered.
Real | getRenderingMinPixelSize () const
| Returns the minimum pixel size an object needs to be in both screen axes in order to be rendered.
uint8 | getRenderQueueGroup (void) const
| Gets the queue group for this entity.
const Any & | getUserAny (void) const
UserObjectBindings & | getUserObjectBindings ()
| Class that provides convenient interface to establish a linkage between custom user application objects and Ogre core classes.
const UserObjectBindings & | getUserObjectBindings () const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual uint32 | getVisibilityFlags (void) const
| Returns the visibility flags relevant for this object.
bool | getVisible (void) const
| Gets this object whether to be visible or not, if it has a renderable component.
const AxisAlignedBox & | getWorldBoundingBox (bool derive=false) const override
| Retrieves the axis-aligned bounding box for this object in world coordinates.
virtual const Sphere & | getWorldBoundingSphere (bool derive=false) const
| Retrieves the worldspace bounding sphere for this object.
bool | isAttached (void) const
| Returns true if this object is attached to a SceneNode or TagPoint.
bool | isDebugDisplayEnabled (void) const
| Gets whether debug display of this object is enabled.
virtual bool | isInScene (void) const
| Returns true if this object is attached to a SceneNode or TagPoint, and this SceneNode / TagPoint is currently in an active part of the scene graph.
bool | isParentTagPoint () const
| Gets whether the parent node is a TagPoint (or a SceneNode).
virtual bool | isVisible (void) const
| Returns whether or not this object is supposed to be visible or not.
const LightList & | queryLights (void) const
| Gets a list of lights, ordered relative to how close they are to this movable object.
void | removeQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | removeVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | setCastShadows (bool enabled)
| Sets whether or not this object will cast shadows.
void | setDebugDisplayEnabled (bool enabled)
| Sets whether or not the debug display of this object is enabled.
void | setLightMask (uint32 lightMask)
| Set a bitwise mask which will filter the lights affecting this object.
void | setListener (Listener *listener)
| Sets a listener for this object.
void | setQueryFlags (uint32 flags)
| Sets the query flags for this object.
void | setRenderingDistance (Real dist)
| Sets the distance at which the object is no longer rendered.
void | setRenderingMinPixelSize (Real pixelSize)
| Sets the minimum pixel size an object needs to be in both screen axes in order to be rendered.
virtual void | setRenderQueueGroup (uint8 queueID)
| Sets the render queue group this entity will be rendered through.
virtual void | setRenderQueueGroupAndPriority (uint8 queueID, ushort priority)
| Sets the render queue group and group priority this entity will be rendered through.
void | setUserAny (const Any &anything)
void | setVisibilityFlags (uint32 flags)
| Sets the visibility flags for this object.
void | setVisible (bool visible)
| Tells this object whether to be visible or not, if it has a renderable component.
Public Member Functions inherited from Ogre::ShadowCaster
virtual | ~ShadowCaster ()
const AxisAlignedBox & | getDarkCapBounds (const Light &light, Real dirLightExtrusionDist) const
| Gets the world space bounding box of the dark cap, as extruded using the light provided.
virtual EdgeData * | getEdgeList (void)
| Returns details of the edges which might be used to determine a silhouette.
const AxisAlignedBox & | getLightCapBounds (void) const
| Gets the world space bounding box of the light cap.
virtual const ShadowRenderableList & | getShadowVolumeRenderableList (const Light *light, const HardwareIndexBufferPtr &indexBuffer, size_t &indexBufferUsedSize, float extrusionDistance, int flags=0)
| Gets an list of the renderables required to render the shadow volume.
bool | hasEdgeList ()
| Returns whether the object has a valid edge list.
Public Member Functions inherited from Ogre::AnimableObject
| AnimableObject ()
virtual | ~AnimableObject ()
virtual AnimableValuePtr | createAnimableValue (const String &valueName)
| Create a reference-counted AnimableValuePtr for the named value.
virtual const StringVector & | getAnimableValueNames (void) const
| Gets a list of animable value names for this object.
Public Member Functions inherited from Ogre::Renderable
| Renderable ()
virtual | ~Renderable ()
| Virtual destructor needed as class has virtual methods.
uint16 | _getMaterialLodIndex () const
virtual void | _updateCustomGpuParameter (const GpuProgramParameters::AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.
const Vector4f & | getCustomParameter (size_t index) const
| Gets the custom value associated with this Renderable at the given index.
virtual uint16 | getNumWorldTransforms (void) const
| Returns the number of world transform matrices this renderable requires.
bool | getPolygonModeOverrideable (void) const
| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
virtual Technique * | getTechnique (void) const
| Retrieves a pointer to the Material Technique this renderable object uses.
bool | getUseIdentityProjection (void) const
| Returns whether or not to use an 'identity' projection.
bool | getUseIdentityView (void) const
| Returns whether or not to use an 'identity' view.
const Any & | getUserAny (void) const
UserObjectBindings & | getUserObjectBindings ()
| Class that provides convenient interface to establish a linkage between custom user application objects and Ogre core classes.
const UserObjectBindings & | getUserObjectBindings () const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
bool | hasCustomParameter (size_t index) const
| Checks whether a custom value is associated with this Renderable at the given index.
virtual void | postRender (SceneManager *sm, RenderSystem *rsys)
| Called immediately after the Renderable has been rendered.
virtual bool | preRender (SceneManager *sm, RenderSystem *rsys)
| Called just prior to the Renderable being rendered.
void | removeCustomParameter (size_t index)
| Removes a custom value which is associated with this Renderable at the given index.
void | setCustomParameter (size_t index, const Vector4f &value)
| Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.
void | setPolygonModeOverrideable (bool override)
| Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection.
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view.
void | setUserAny (const Any &anything)

## Additional Inherited Members
Public Types inherited from Ogre::ShadowCaster
typedef Ogre::ShadowRenderableList | ShadowRenderableList
typedef VectorIterator< ShadowRenderableList > | ShadowRenderableListIterator
Public Types inherited from Ogre::Renderable
enum | { DEFAULT_PRIORITY = 100 }
Static Public Member Functions inherited from Ogre::MovableObject
static uint32 | getDefaultQueryFlags ()
| Get the default query flags for all future MovableObject instances.
static uint32 | getDefaultVisibilityFlags ()
| Get the default visibility flags for all future MovableObject instances.
static void | setDefaultQueryFlags (uint32 flags)
| Set the default query flags for all future MovableObject instances.
static void | setDefaultVisibilityFlags (uint32 flags)
| Set the default visibility flags for all future MovableObject instances.
Static Public Member Functions inherited from Ogre::ShadowCaster
static void | clearShadowRenderableList (ShadowRenderableList &shadowRenderables)
| Common implementation of releasing shadow renderables.
static void | extrudeVertices (const HardwareVertexBufferSharedPtr &vertexBuffer, size_t originalVertexCount, const Vector4 &lightPos, Real extrudeDist)
| Utility method for extruding vertices based on a light.

## Detailed Description

A collection of billboards (faces which are always facing the given direction) with the same (default) dimensions, material and which are fairly close proximity to each other.

Billboards are rectangles made up of 2 tris which are always facing the given direction. They are typically used for special effects like particles. This class collects together a set of billboards with the same (default) dimensions, material and relative locality in order to process them more efficiently. The entire set of billboards will be culled as a whole (by default, although this can be changed if you want a large set of billboards which are spread out and you want them culled individually), individual Billboards have locations which are relative to the set (which itself derives it's position from the SceneNode it is attached to since it is a MoveableObject), they will be rendered as a single rendering operation, and some calculations will be sped up by the fact that they use the same dimensions so some workings can be reused.

  A BillboardSet can be created using the SceneManager::createBillboardSet method. They can also be used internally by other classes to create effects.

Note
  Billboard bounds are only automatically calculated when you create them. If you modify the position of a billboard you may need to call _updateBounds if the billboard moves outside the original bounds. Similarly, the bounds do no shrink when you remove a billboard, if you want them to call _updateBounds, but note this requires a potentially expensive examination of every billboard in the set.

## Constructor & Destructor Documentation

## ◆ BillboardSet()

Ogre::BillboardSet::BillboardSet | ( | const String & | name,
|  | unsigned int | poolSize = 20,
|  | bool | externalDataSource = false )

Usual constructor - this is called by the SceneManager.

Parameters

  name | The name to give the billboard set (must be unique)
  poolSize | The initial size of the billboard pool. Estimate of the number of billboards which will be required, and pass it using this parameter. The set will preallocate this number to avoid memory fragmentation. The default behaviour once this pool has run out is to double it.
  externalDataSource | If `true`, the source of data for drawing the billboards will not be the internal billboard list, but external data. When driving the billboard from external data, you must call _notifyCurrentCamera to reorient the billboards, setPoolSize to set the maximum billboards you want to use, beginBillboards to start the update, and injectBillboard per billboard, followed by endBillboards.

See also
  BillboardSet::setAutoextend

## ◆ ~BillboardSet()

virtual Ogre::BillboardSet::~BillboardSet | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ createBillboard() [1/2]

Billboard * Ogre::BillboardSet::createBillboard | ( | const Vector3 & | position,
|  | const ColourValue & | colour = ColourValue::White )

Creates a new billboard and adds it to this set.

Behaviour once the billboard pool has been exhausted depends on the BillboardSet::setAutoextend option.

Parameters

  position | The position of the new billboard relative to the center of the set
  colour | Optional base colour of the billboard.

Returns
  On success, a pointer to a newly created Billboard is returned.

  On failure (i.e. no more space and can't autoextend), `NULL` is returned.

See also
  BillboardSet::setAutoextend

References Ogre::ColourValue::White.

Referenced by createBillboard().

## ◆ createBillboard() [2/2]

Billboard * Ogre::BillboardSet::createBillboard | ( | Real | x,
|  | Real | y,
|  | Real | z,
|  | const ColourValue & | colour = ColourValue::White )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References createBillboard(), and Ogre::ColourValue::White.

## ◆ getNumBillboards()

int Ogre::BillboardSet::getNumBillboards | ( | void |  | ) | const
| inline

Returns the number of active billboards which currently make up this set.

## ◆ setAutoextend()

void Ogre::BillboardSet::setAutoextend | ( | bool | autoextend | ) |
| inline

Tells the set whether to allow automatic extension of the pool of billboards.

A BillboardSet stores a pool of pre-constructed billboards which are used as needed when a new billboard is requested. This allows applications to create / remove billboards efficiently without incurring construction / destruction costs (a must for sets with lots of billboards like particle effects). This method allows you to configure the behaviour when a new billboard is requested but the billboard pool has been exhausted.

  The default behaviour is to allow the pool to extend (typically this allocates double the current pool of billboards when the pool is expended), equivalent to calling this method with autoExtend = true. If you set the parameter to false however, any attempt to create a new billboard when the pool has expired will simply fail silently, returning a null pointer.

Parameters

  autoextend | `true` to double the pool every time it runs out, `false` to fail silently.

## ◆ getAutoextend()

bool Ogre::BillboardSet::getAutoextend | ( | void |  | ) | const
| inline

Returns true if the billboard pool automatically extends.

See also
  BillboardSet::setAutoextend

## ◆ setSortingEnabled()

void Ogre::BillboardSet::setSortingEnabled | ( | bool | sortenable | ) |
| inline

Enables sorting for this BillboardSet.

(default: off)

Parameters

  sortenable | true to sort the billboards according to their distance to the camera

## ◆ getSortingEnabled()

bool Ogre::BillboardSet::getSortingEnabled | ( | void |  | ) | const
| inline

Returns true if sorting of billboards is enabled based on their distance from the camera.

See also
  BillboardSet::setSortingEnabled

## ◆ setPoolSize()

void Ogre::BillboardSet::setPoolSize | ( | size_t | size | ) |

Adjusts the size of the pool of billboards available in this set.

See the BillboardSet::setAutoextend method for full details of the billboard pool. This method adjusts the preallocated size of the pool. If you try to reduce the size of the pool, the set has the option of ignoring you if too many billboards are already in use. Bear in mind that calling this method will incur significant construction / destruction calls so should be avoided in time-critical code. The same goes for auto-extension, try to avoid it by estimating the pool size correctly up-front.

Parameters

  size | The new size for the pool.

## ◆ getPoolSize()

unsigned int Ogre::BillboardSet::getPoolSize | ( |  | ) | const
| inline

Returns the current size of the billboard pool.

Returns
  The current size of the billboard pool.

See also
  BillboardSet::setAutoextend

## ◆ clear()

virtual void Ogre::BillboardSet::clear | ( |  | ) |
| virtual

Empties this set of all billboards.

## ◆ getBillboard()

virtual Billboard * Ogre::BillboardSet::getBillboard | ( | unsigned int | index | ) | const
| virtual

Returns a pointer to the billboard at the supplied index.

Parameters

  index | The index of the billboard that is requested.

Returns
  On success, a valid pointer to the requested billboard is returned.

  On failure, `NULL` is returned.

## ◆ removeBillboard() [1/2]

virtual void Ogre::BillboardSet::removeBillboard | ( | unsigned int | index | ) |
| virtual

Removes the billboard at the supplied index.

## ◆ removeBillboard() [2/2]

virtual void Ogre::BillboardSet::removeBillboard | ( | Billboard * | pBill | ) |
| virtual

Removes a billboard from the set.

## ◆ setBillboardOrigin()

void Ogre::BillboardSet::setBillboardOrigin | ( | BillboardOrigin | origin | ) |
| inline

Sets the point which acts as the origin point for all billboards in this set.

This setting controls the fine tuning of where a billboard appears in relation to it's position. It could be that a billboard's position represents it's center (e.g. for fireballs), it could mean the center of the bottom edge (e.g. a tree which is positioned on the ground), the top-left corner (e.g. a cursor).

The default setting is BBO_CENTER.

Parameters

  origin | A member of the BillboardOrigin enum specifying the origin for all the billboards in this set.

## ◆ getBillboardOrigin()

BillboardOrigin Ogre::BillboardSet::getBillboardOrigin | ( | void |  | ) | const
| inline

Gets the point which acts as the origin point for all billboards in this set.

Returns
  A member of the BillboardOrigin enum specifying the origin for all the billboards in this set.

## ◆ setBillboardRotationType()

void Ogre::BillboardSet::setBillboardRotationType | ( | BillboardRotationType | rotationType | ) |
| inline

Sets billboard rotation type.

This setting controls the billboard rotation type, you can deciding rotate the billboard's vertices around their facing direction or rotate the billboard's texture coordinates.

The default settings is BBR_TEXCOORD.

Parameters

  rotationType | A member of the BillboardRotationType enum specifying the rotation type for all the billboards in this set.

## ◆ getBillboardRotationType()

BillboardRotationType Ogre::BillboardSet::getBillboardRotationType | ( | void |  | ) | const
| inline

Sets billboard rotation type.

Returns
  A member of the BillboardRotationType enum specifying the rotation type for all the billboards in this set.

## ◆ setDefaultDimensions()

void Ogre::BillboardSet::setDefaultDimensions | ( | Real | width,
|  | Real | height )
| inline

Sets the default dimensions of the billboards in this set.

All billboards in a set are created with these default dimensions. The set will render most efficiently if all the billboards in the set are the default size. It is possible to alter the size of individual billboards at the expense of extra calculation. See the Billboard class for more info.

Parameters

  width | The new default width for the billboards in this set.
  height | The new default height for the billboards in this set.

## ◆ setDefaultWidth()

void Ogre::BillboardSet::setDefaultWidth | ( | Real | width | ) |
| inline

See setDefaultDimensions - this sets 1 component individually.

## ◆ getDefaultWidth()

Real Ogre::BillboardSet::getDefaultWidth | ( | void |  | ) | const
| inline

See setDefaultDimensions - this gets 1 component individually.

## ◆ setDefaultHeight()

void Ogre::BillboardSet::setDefaultHeight | ( | Real | height | ) |
| inline

See setDefaultDimensions - this sets 1 component individually.

## ◆ getDefaultHeight()

Real Ogre::BillboardSet::getDefaultHeight | ( | void |  | ) | const
| inline

See setDefaultDimensions - this gets 1 component individually.

## ◆ setMaterialName()

virtual void Ogre::BillboardSet::setMaterialName | ( | const String & | name,
|  | const String & | groupName = ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME )
| virtual

Sets the name of the material to be used for this billboard set.

References Ogre::ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME.

## ◆ getMaterialName()

const String & Ogre::BillboardSet::getMaterialName | ( | void |  | ) | const
| inline

Sets the name of the material to be used for this billboard set.

Returns
  The name of the material that is used for this set.

## ◆ _notifyCurrentCamera()

void Ogre::BillboardSet::_notifyCurrentCamera | ( | Camera * | cam | ) |
| overridevirtual

Internal method to notify the object of the camera to be used for the next rendering operation.

Certain objects may want to do specific processing based on the camera position. This method notifies them in case they wish to do this.

Reimplemented from Ogre::MovableObject.

## ◆ beginBillboards()

void Ogre::BillboardSet::beginBillboards | ( | size_t | numBillboards = 0 | ) |

Begin injection of billboard data; applicable when constructing the BillboardSet for external data use.

Parameters

  numBillboards | If you know the number of billboards you will be issuing, state it here to make the update more efficient.

## ◆ injectBillboard()

void Ogre::BillboardSet::injectBillboard | ( | const Billboard & | bb | ) |

Define a billboard.

## ◆ endBillboards()

void Ogre::BillboardSet::endBillboards | ( | void |  | ) |

Finish defining billboards.

## ◆ setBounds()

void Ogre::BillboardSet::setBounds | ( | const AxisAlignedBox & | box,
|  | Real | radius )

Set the bounds of the BillboardSet.

You may need to call this if you're injecting billboards manually, and you're relying on the BillboardSet to determine culling.

## ◆ getBoundingBox()

const AxisAlignedBox & Ogre::BillboardSet::getBoundingBox | ( | void |  | ) | const
| inlineoverridevirtual

Retrieves the local axis-aligned bounding box for this object.

This bounding box is in local coordinates.

Implements Ogre::MovableObject.

## ◆ getBoundingRadius()

Real Ogre::BillboardSet::getBoundingRadius | ( | void |  | ) | const
| inlineoverridevirtual

Retrieves the radius of the origin-centered bounding sphere for this object.

Implements Ogre::MovableObject.

## ◆ _updateRenderQueue()

void Ogre::BillboardSet::_updateRenderQueue | ( | RenderQueue * | queue | ) |
| overridevirtual

Internal method by which the movable object must add Renderable subclass instances to the rendering queue.

The engine will call this method when this object is to be rendered. The object must then create one or more Renderable subclass instances which it places on the passed in Queue for rendering.

Implements Ogre::MovableObject.

## ◆ getMaterial()

const MaterialPtr & Ogre::BillboardSet::getMaterial | ( | void |  | ) | const
| inlineoverridevirtual

Retrieves a weak reference to the material this renderable object uses.

Note that the Renderable also has the option to override the getTechnique method to specify a particular Technique to use instead of the best one available.

Implements Ogre::Renderable.

## ◆ setMaterial()

virtual void Ogre::BillboardSet::setMaterial | ( | const MaterialPtr & | material | ) |
| virtual

Sets the name of the material to be used for this billboard set.

Parameters

  material | The new material to use for this set.

## ◆ getRenderOperation()

void Ogre::BillboardSet::getRenderOperation | ( | RenderOperation & | op | ) |
| overridevirtual

Gets the render operation required to send this object to the frame buffer.

Implements Ogre::Renderable.

## ◆ getWorldTransforms()

void Ogre::BillboardSet::getWorldTransforms | ( | Matrix4 * | xform | ) | const
| overridevirtual

Gets the world transform matrix / matrices for this renderable object.

If the object has any derived transforms, these are expected to be up to date as long as all the SceneNode structures have been updated before this is called.

Note
  Internal Ogre never supports non-affine matrix for world transform matrix/matrices, the behavior is undefined if returns non-affine matrix here.

This method will populate transform with 1 matrix if it does not use GPU vertex blending. If it does use GPU vertex blending it will fill the passed in pointer with an array of matrices, the length being the value returned from getNumWorldTransforms.

Note
  If MeshManager::getBonesUseObjectSpace() is true, the first matrix must contain the world transform of the object, and the rest of the matrices must contain the bone transforms in object space.

Implements Ogre::Renderable.

## ◆ getCullIndividually()

bool Ogre::BillboardSet::getCullIndividually | ( | void |  | ) | const
| inline

Returns whether or not billboards in this are tested individually for culling.

## ◆ setCullIndividually()

void Ogre::BillboardSet::setCullIndividually | ( | bool | cullIndividual | ) |
| inline

Sets whether culling tests billboards in this individually as well as in a group.

Billboard sets are always culled as a whole group, based on a bounding box which encloses all billboards in the set. For fairly localised sets, this is enough. However, you can optionally tell the set to also cull individual billboards in the set, i.e. to test each individual billboard before rendering. The default is not to do this.

  This is useful when you have a large, fairly distributed set of billboards, like maybe trees on a landscape. You probably still want to group them into more than one set (maybe one set per section of landscape), which will be culled coarsely, but you also want to cull the billboards individually because they are spread out. Whilst you could have lots of single-tree sets which are culled separately, this would be inefficient to render because each tree would be issued as it's own rendering operation.

  By calling this method with a parameter of true, you can have large billboard sets which are spaced out and so get the benefit of batch rendering and coarse culling, but also have fine-grained culling so unnecessary rendering is avoided.

Parameters

  cullIndividual | If true, each billboard is tested before being sent to the pipeline as well as the whole set having to pass the coarse group bounding test.

## ◆ setBillboardType()

void Ogre::BillboardSet::setBillboardType | ( | BillboardType | bbt | ) |
| inline

Sets the orientation behaviour of the billboards to render.

The default sort of billboard (BBT_POINT), always has both x and y axes parallel to the camera's local axes. This is fine for 'point' style billboards (e.g. flares, smoke, anything which is symmetrical about a central point) but does not look good for billboards which have an orientation (e.g. an elongated raindrop). In this case, the oriented billboards are more suitable (BBT_ORIENTED_COMMON or BBT_ORIENTED_SELF) since they retain an independent Y axis and only the X axis is generated, perpendicular to both the local Y and the camera Z.

In some case you might want the billboard has fixed Z axis and doesn't need to face to camera (e.g. an aureola around the player and parallel to the ground). You can use BBT_PERPENDICULAR_SELF which the billboard plane perpendicular to the billboard own direction. Or BBT_PERPENDICULAR_COMMON which the billboard plane perpendicular to the common direction.

Note
  BBT_PERPENDICULAR_SELF and BBT_PERPENDICULAR_COMMON can't guarantee counterclockwise, you might use double-side material (CULL_NONE) to ensure no billboard are culled.

Parameters

  bbt | The type of billboard to render

## ◆ getBillboardType()

BillboardType Ogre::BillboardSet::getBillboardType | ( | void |  | ) | const
| inline

Returns the billboard type in use.

## ◆ setCommonDirection()

void Ogre::BillboardSet::setCommonDirection | ( | const Vector3 & | vec | ) |
| inline

Use this to specify the common direction given to billboards.

Use BBT_ORIENTED_COMMON when you want oriented billboards but you know they are always going to be oriented the same way (e.g. rain in calm weather). It is faster for the system to calculate the billboard vertices if they have a common direction.

The common direction also use in BBT_PERPENDICULAR_COMMON, in this case the common direction treat as Z axis, and an additional common up-vector was use to determine billboard X and Y axis.

Parameters

  vec | The direction for all billboards. The vector is expected to be unit-length (normalised)

See also
  setCommonUpVector

## ◆ getCommonDirection()

const Vector3 & Ogre::BillboardSet::getCommonDirection | ( | void |  | ) | const
| inline

Gets the common direction for all billboards (BBT_ORIENTED_COMMON).

## ◆ setCommonUpVector()

void Ogre::BillboardSet::setCommonUpVector | ( | const Vector3 & | vec | ) |
| inline

Use this to specify the common up-vector given to billboards.

Use BBT_PERPENDICULAR_SELF or BBT_PERPENDICULAR_COMMON when you want oriented billboards perpendicular to specify direction vector (or, Z axis), and doesn't face to camera. In this case, we need an additional up-vector to determine the billboard X and Y axis. The generated billboard plane and X-axis guarantee perpendicular to specify direction.

The specify direction is billboard own direction when billboard type is BBT_PERPENDICULAR_SELF, and it's shared common direction when billboard type is BBT_PERPENDICULAR_COMMON.

Parameters

  vec | The up-vector for all billboards. The vector is expected to be unit-length (normalised)

See also
  setCommonDirection

## ◆ getCommonUpVector()

const Vector3 & Ogre::BillboardSet::getCommonUpVector | ( | void |  | ) | const
| inline

Gets the common up-vector for all billboards (BBT_PERPENDICULAR_SELF and BBT_PERPENDICULAR_COMMON).

## ◆ setUseAccurateFacing()

void Ogre::BillboardSet::setUseAccurateFacing | ( | bool | acc | ) |
| inline

Sets whether or not billboards should use an 'accurate' facing model.

By default, the axes for all billboards are calculated using the camera's view direction, not the vector from the camera position to the billboard. The former is faster, and most of the time the difference is not noticeable. However for some purposes (e.g. very large, static billboards) the changing billboard orientation when rotating the camera can be off putting, therefore you can enable this option to use a more expensive, but more accurate version.

Parameters

  acc | True to use the slower but more accurate model. Default is false.

## ◆ getUseAccurateFacing()

bool Ogre::BillboardSet::getUseAccurateFacing | ( | void |  | ) | const
| inline

Gets whether or not billboards use an 'accurate' facing model.

based on the vector from each billboard to the camera, rather than an optimised version using just the camera direction.

## ◆ getMovableType()

const String & Ogre::BillboardSet::getMovableType | ( | void |  | ) | const
| overridevirtual

Returns the type name of this object.

Implements Ogre::MovableObject.

## ◆ getSquaredViewDepth()

Real Ogre::BillboardSet::getSquaredViewDepth | ( | const Camera * | cam | ) | const
| overridevirtual

Returns the squared distance between the camera and this renderable.

Used to sort transparent objects. Squared distance is used to avoid having to perform a square root on the result.

Implements Ogre::Renderable.

## ◆ _updateBounds()

virtual void Ogre::BillboardSet::_updateBounds | ( | void |  | ) |
| virtual

Update the bounds of the billboardset.

## ◆ getLights()

const LightList & Ogre::BillboardSet::getLights | ( | void |  | ) | const
| overridevirtual

Gets a list of lights, ordered relative to how close they are to this renderable.

Directional lights, which have no position, will always be first on this list.

Implements Ogre::Renderable.

## ◆ visitRenderables()

void Ogre::BillboardSet::visitRenderables | ( | Renderable::Visitor * | visitor,
|  | bool | debugRenderables = false )
| overridevirtual

Method to allow a caller to abstractly iterate over the Renderable instances that this MovableObject will add to the render queue when asked, if any.

Parameters

  visitor | Pointer to a class implementing the Renderable::Visitor interface which will be called back for each Renderable which will be queued. Bear in mind that the state of the Renderable instances may not be finalised depending on when you call this.
  debugRenderables | If false, only regular renderables will be visited (those for normal display). If true, debug renderables will be included too.

Implements Ogre::MovableObject.

## ◆ _sortBillboards()

virtual void Ogre::BillboardSet::_sortBillboards | ( | Camera * | cam | ) |
| virtual

Sort the billboard set.

Only called when enabled via setSortingEnabled

## ◆ _getSortMode()

virtual SortMode Ogre::BillboardSet::_getSortMode | ( | void |  | ) | const
| virtual

Gets the sort mode of this billboard set.

## ◆ setBillboardsInWorldSpace()

void Ogre::BillboardSet::setBillboardsInWorldSpace | ( | bool | ws | ) |
| inline

Sets whether billboards should be treated as being in world space.

This is most useful when you are driving the billboard set from an external data source.

## ◆ getBillboardsInWorldSpace()

bool Ogre::BillboardSet::getBillboardsInWorldSpace | ( |  | ) |
| inline

Gets whether billboards are treated as being in world space.

## ◆ setTextureCoords() [1/2]

void Ogre::BillboardSet::setTextureCoords | ( | const std::vector< FloatRect > & | coords | ) |

BillboardSet can use custom texture coordinates for various billboards.

This is useful for selecting one of many particle images out of a tiled texture sheet, or doing flipbook animation within a single texture.

  The generic functionality is setTextureCoords(), which will copy the texture coordinate rects you supply into internal storage for the billboard set. If your texture sheet is a square grid, you can also use setTextureStacksAndSlices() for more convenience, which will construct the set of texture coordinates for you.

  When a Billboard is created, it can be assigned a texture coordinate set from within the sets you specify (that set can also be re-specified later). When drawn, the billboard will use those texture coordinates, rather than the full 0-1 range.

Parameters

  coords | is a vector of texture coordinates (in UV space) to choose from for each billboard created in the set.

Set 'coords' to 0 and/or 'numCoords' to 0 to reset the texture coord rects to the initial set of a single rectangle spanning 0 through 1 in both U and V (i e, the entire texture).

See also
  BillboardSet::setTextureStacksAndSlices() Billboard::setTexcoordIndex()

Referenced by setTextureCoords().

## ◆ setTextureCoords() [2/2]

void Ogre::BillboardSet::setTextureCoords | ( | FloatRect const * | coords,
|  | uint16 | numCoords )
| inline

Deprecated

References setTextureCoords().

## ◆ setTextureStacksAndSlices()

void Ogre::BillboardSet::setTextureStacksAndSlices | ( | uchar | stacks,
|  | uchar | slices )

Generate texture coordinate rects for a tiled texture sheet.

A texture sheet is a grid of images that can be used to create simple animations. This method will generate the uv coordinates for the individual sub-rectangles.

These can then be addressed by Ogre::Billboard::setTexcoordIndex().

If the texture size is 512x512 and 'stacks' is 4 and 'slices' is 8, each sub-rectangle of the texture would be 128 texels tall and 64 texels wide.

The numbering counts first across, then down, so top-left is 0, the one to the right of that is 1, and the lower-right is stacks*slices-1.

If you need more flexibility, you can use Ogre::BillboardSet::setTextureCoords() instead.

Parameters

  stacks | number of vertical tiles (rows)
  slices | number of horizontal tiles (columns)

## ◆ getTextureCoords()

const std::vector< FloatRect > & Ogre::BillboardSet::getTextureCoords | ( |  | ) | const
| inline

getTextureCoords() returns the current texture coordinate rects in effect.

By default, there is only one texture coordinate rect in the set, spanning the entire texture from 0 through 1 in each direction.

See also
  BillboardSet::setTextureCoords()

## ◆ setPointRenderingEnabled()

virtual void Ogre::BillboardSet::setPointRenderingEnabled | ( | bool | enabled | ) |
| virtual

Set whether or not the BillboardSet will use point rendering rather than manually generated quads.

By default a billboardset is rendered by generating geometry for a textured quad in memory, taking into account the size and orientation settings, and uploading it to the video card. The alternative is to use hardware point rendering, which means that only one position needs to be sent per billboard rather than 4 and the hardware sorts out how this is rendered based on the render state.

Using point rendering is faster than generating quads manually, but is more restrictive. The following restrictions apply:

- Only the Ogre::BBT_POINT type is supported
- Size and appearance of each billboard is controlled by the material
  - Ogre::Pass::setPointSize
  - Ogre::Pass::setPointAttenuation
  - Ogre::Pass::setPointSpritesEnabled
- Per-billboard size is not supported (stems from the above)
- Per-billboard rotation is not supported, this can only be controlled through texture unit rotation
- Only Ogre::BBO_CENTER origin is supported
- Per-billboard texture coordinates are not supported

You will almost certainly want to enable in your material pass both point attenuation and point sprites if you use this option.

## ◆ isPointRenderingEnabled()

bool Ogre::BillboardSet::isPointRenderingEnabled | ( | void |  | ) | const
| inline

Returns whether point rendering is enabled.

## ◆ getTypeFlags()

uint32 Ogre::BillboardSet::getTypeFlags | ( | void |  | ) | const
| overridevirtual

Override to return specific type flag.

Reimplemented from Ogre::MovableObject.

## ◆ setAutoUpdate()

void Ogre::BillboardSet::setAutoUpdate | ( | bool | autoUpdate | ) |

Set the auto update state of this billboard set.

This methods controls the updating policy of the vertex buffer. By default auto update is true so the vertex buffer is being update every time this billboard set is about to be rendered. This behavior best fit when the billboards of this set changes frequently. When using static or semi-static billboards, it is recommended to set auto update to false. In that case one should call notifyBillboardDataChanged method to reflect changes made to the billboards data.

## ◆ getAutoUpdate()

bool Ogre::BillboardSet::getAutoUpdate | ( | void |  | ) | const
| inline

Return the auto update state of this billboard set.

## ◆ notifyBillboardDataChanged()

void Ogre::BillboardSet::notifyBillboardDataChanged | ( | void |  | ) |
| inline

When billboard set is not auto updating its GPU buffer, the user is responsible to inform it about any billboard changes in order to reflect them at the rendering stage.

Calling this method will cause GPU buffers update in the next render queue update.

## ◆ _releaseManualHardwareResources()

void Ogre::BillboardSet::_releaseManualHardwareResources | ( |  | ) |
| inlineoverridevirtual

Notifies the movable object that hardware resources were lost.

Called automatically by RenderSystem if hardware resources were lost and can not be restored using some internal mechanism. Among affected resources are nested shadow renderables, ManualObjects, etc.

Reimplemented from Ogre::MovableObject.

The documentation for this class was generated from the following file:

- OgreBillboardSet.h